mod Maux

incl Mtex

incl Mtexpl

rem 
  \para \bf  Lists.  \end 

fun L 
  L(0) = 0
  L(v,w) = L(w)+1

appldisp/2 Tex_f2_ln_sub
  Prefix(70,2,Arg(0),Fenced(Op('[',0),Arg(1),Op(']',0)))

fun/2 Sub 'Tex_f2_ln_sub'
  Sub((v,w),0) = v
  Sub((v,w),i+1) = Sub(w,i)

rem 
  \para \bf  Finite sets.  \end 

pred Set 
  Set(s) <-> \a i\a j(i < j & j < L(s) -> Sub(s,i) < Sub(s,j))

rem 
  \para \bf  Propositional logic.  \end 

rem 
  \para \it  Arithmetization.  \end 

fun/0 Tc 'Tex_f0_pl_tc'
  Tc = 0,0

fun/0 Fc 'Tex_f0_pl_fc'
  Fc = 1,0

fun Pvar 'Tex_f1_pl_pvar'
  Pvar(i) = 2,i

fun Not 'Tex_f1_pl_not'
  Not(a) = 3,a

fun/2 And 'Tex_f2_pl_and'
  And(a,b) = 4,a,b

fun/2 Or 'Tex_f2_pl_or'
  Or(a,b) = 5,a,b

fun/2 Imp 'Tex_f2_pl_imp'
  Imp(a,b) = 6,a,b

fun/2 Iff 'Tex_f2_pl_iff'
  Iff(a,b) = 7,a,b

pred Form 
  Form(Tc)
  Form(Fc)
  Form Pvar(i) <- N(i)
  Form Not(a) <- Form(a)
  Form And(a,b) <- Form(a) & Form(b)
  Form Or(a,b) <- Form(a) & Form(b)
  Form Imp(a,b) <- Form(a) & Form(b)
  Form Iff(a,b) <- Form(a) & Form(b)

rem 
  \para \it  Basic operations and predicates.  \end 

pred/2 True 'Tex_p2_pl_true'
  True(v,Tc)
  True(v,Pvar(i)) <- i in v
  True(v,Not(a)) <- ~True(v,a)
  True(v,And(a,b)) <- True(v,a) & True(v,b)
  True(v,Or(a,b)) <- True(v,a)
  True(v,Or(a,b)) <- ~True(v,a) & True(v,b)
  True(v,Imp(a,b)) <- ~True(v,a)
  True(v,Imp(a,b)) <- True(v,a) & True(v,b)
  True(v,Iff(a,b)) <- True(v,a) & True(v,b)
  True(v,Iff(a,b)) <- ~True(v,a) & ~True(v,b)

